function [sequenceIndex I_err_Challenger I_err_Challenger_intersection log] = evaluateGlobalTraj(sequenceIndex,globalTraj,modules,it,log,varargin)
%% parsing inputs
if isempty(varargin)
    options = check_options();
else
    options = check_options(varargin{1}); % Checking the given options, and add ones are not defined.
end

%% start first sequence
% go through seqence
correlationIndex=0;
V= zeros(length(sequenceIndex{it})-1,1);
Vmse= zeros(length(sequenceIndex{it})-1,1);
I_err= zeros(1,length(sequenceIndex{it})-1);
V_err= zeros(1,length(sequenceIndex{it})-1);

I_Minerr= zeros(1,length(sequenceIndex{it})-1);
V_Minerr= zeros(1,length(sequenceIndex{it})-1);

collectIntersections= zeros(1,length(sequenceIndex{it})-1);
boxcriteria= zeros(1,length(sequenceIndex{it})-1);
Index_collector= zeros(1,length(sequenceIndex{it})-1);
BestPrimitiv_collector= zeros(1,length(sequenceIndex{it})-1);
Min_Index_collector= zeros(1,length(sequenceIndex{it})-1);
reproGlobalTraj=[];
corrGlobalTraj=[];
corrStraightTraj=[];

collectMPIndexes=[];
disp(' ')
%% Add viaPoint

    
    

for ik=1:length(sequenceIndex{it})-1;
    %% evaluate Performance of the modules.shape (we look here only at the geometrical structure)
    startIndex=sequenceIndex{it}(ik);
    endIndex=sequenceIndex{it}(ik+1)-1;
    
    disp(['Find Best shape for sequence: ' num2str(startIndex) '-' num2str(endIndex)])
    demos{1}=globalTraj(startIndex:endIndex,:)';
    offsetMain = [demos{1}(1:2,end) ;0;0];
    demos{1}=demos{1}-repmat(offsetMain,1,size(demos{1},2));
    
     startP = repmat(demos{1}(1:2,1),1,length(modules.shapes))';
    shapefig=[];
    [ demos2 repros fitnessValue MSE logging]=checkTrajectorieSegments(modules,demos,startP);
    
    %% best module will be used to find next segmentation points
    
    % identify index of best Shape (MSE)
    tmpMSE=cell2mat(MSE);
   
   
    [Vmse(ik) IndexOfBestMP]=min(tmpMSE);
    collectIntersections(ik) = (getRobustIntersections(demos2,repros,IndexOfBestMP,options.mVmin) || logging.boxCriteria(IndexOfBestMP));

    % calculate error per trajectory point
    err= trajectoryMeasureMSE(demos2{IndexOfBestMP}(1:2,:),repros{IndexOfBestMP}(1:2,:));

    % get pointIndex with maximum error for this segment
    [V_err(ik) I_err(ik)] = max(err);
       
    % get Index in globaltrajectory context
    Index_collector(ik)=I_err(ik)+startIndex-1;
    BestPrimitiv_collector(ik)=IndexOfBestMP;
    % log best trajectories for plotting
    corrStraightTraj = [corrStraightTraj  repros{IndexOfBestMP}+repmat(offsetMain,1,size(repros{IndexOfBestMP},2)) ];
    corrGlobalTraj = [corrGlobalTraj  demos2{IndexOfBestMP}+repmat(offsetMain,1,size(demos2{IndexOfBestMP},2)) ];
    reproGlobalTraj=[reproGlobalTraj  repros{IndexOfBestMP}+repmat(offsetMain,1,size(repros{IndexOfBestMP},2)) ];
end



corrGlobalTraj=[corrGlobalTraj offsetMain];
reproGlobalTraj=[reproGlobalTraj offsetMain];

% get Index of the point  with the global Maximumerror
V_err(find(~collectIntersections))=-1; % ignore all errors in which we do not find any intersections
[~,a]=max(V_err);

% use Index to identify segment in globalTrajectory for
% optimization
segDemo=globalTraj(sequenceIndex{it}(a):sequenceIndex{it}(a+1)-1,1:2);

%% normalize
% find closest point in GlobalTrajectory
cmpAllPoints=trajectoryMeasureMSE(segDemo', repmat(corrGlobalTraj(1:2,Index_collector(a))',size(segDemo,1),1)');
[vgl igl] =min(cmpAllPoints);
blub=sequenceIndex{it}(a)-1;
correlationIndex=(igl+blub);

maxPointErrTotal=Vmse(a);
disp(['Iteration: ' num2str(it-1) ' Trajectory identified with Maximal ERROR: ' num2str(maxPointErrTotal)])


% add new segmentation point to sequence
sequenceIndex{it+1}=sort([sequenceIndex{it} correlationIndex]);

it=it+1;

% find position of the new added Segmentation Point
I_err_Challenger = find(sequenceIndex{it}==correlationIndex);

if collectIntersections(a)
    I_err_Challenger_intersection=1;
else
    disp(' Point not approved and is deleted in next iteration')
    I_err_Challenger_intersection=-1;
end

if length(I_err_Challenger)>1
    disp('found more than one I_err_Challenger')
end
log.BestPrimitiv =BestPrimitiv_collector;
log.corrGlobalTraj =corrGlobalTraj;
log.reproGlobalTraj=reproGlobalTraj;
log.collectIntersections=collectIntersections;


end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function options = check_options(varargin)
if ~isempty(varargin)
    options = varargin{1};
else
    options.mVmin=0.02; %to create the variable
end

if ~isfield(options,'mVmin') % integration time step
    options.mVmin = 0.02;
end
if ~isfield(options,'mVmax') % maximum number of iterations
    options.mVmax = 1000;
end


end

