function [fig xtmp ax] = PlotGlobalMovement(x,xd,dt,subplotRow,subplotColm,p,fig)
if ~exist('fig','var')
    fig=figure; grid on; hold on; box on;axis equal;
end
if ~exist('subplotRow','var')
    subplotRow=1;
end
if ~exist('subplotColm','var')
    subplotColm=1;
end
if ~exist('p','var')
    p=1;
end
if ~exist('dt','var')
    dt=1;
end

xtmp= zeros(size(xd));
xtmp(:,1,:)= ones(size(xd,1),size(xd,3));
for numTraj=1:size(x,3)
    for i =1: size(x,2)-1
        xtmp(:,i+1,numTraj)=xtmp(:,i,numTraj)+xd(:,i,numTraj)*dt;
    end
end
figure(fig)
ax = subplot(subplotRow,subplotColm,p); hold on;grid on; box on;axis equal;
for i =1:size(x,3)
    plot(xtmp(1,:,i),xtmp(2,:,i),'+')
end
set(gca,'FontSize',15)
if p ==1
    title('global trajectory');
else
    xlabel('x (mm)');
end

ylabel('y (mm)');
daspect([1 1 1])



% winsize = get(fig1,'Position');
% winsize(1:2) = [0 0];
% numframes=size(x,2);
% A=moviein(numframes,fig1,winsize);
% set(fig1,'NextPlot','replacechildren')
% for i =1:size(x,3)
%     for k=1:size(x,2)
%         plot(xtmp(1,k,i),xtmp(2,k,i),'r')
%         hold on;
%         A(:,i)=getframe(fig1,winsize);
%     end
%
%
% end
%
%
%save myMovie.mat A
end