function runDecomposition(numModel, selectedDataSet,record )


fig_Perf=figure;
fig_Perf2=figure;
hold on; grid on; box on;axis equal;
dataPath = ['data' filesep];
%% Load data
fileName{1} ='amarsiWritings';
fileName{2} ='WShape';
fileName{3} ='NShape';
fileName{4} ='Angle';
fileName{5} ='randTestData';
fileName{6} ='randTestDataDiscuntious2';
fileName{7} ='randTestDataDiscuntious';
fileName{5} ='amarsiWritings2';
% TODO: randTestData also contains the optimal solution: this needs to be
% clarified
data = load([dataPath fileName{selectedDataSet}]);

%% Loading the module primitives

PATH_MODEL='model/Flash/';
NAME_MODEL = dir([PATH_MODEL '*X*']);

name =NAME_MODEL(numModel).name;
disp(['LOAD model : ' NAME_MODEL(numModel).name])
load([PATH_MODEL NAME_MODEL(numModel).name]);
modules.shapes=result;
if ~exist('borderbox','var')
    modules.borderbox=findBox(result);
else
    modules.borderbox=borderbox;
end


include_paths;



% data preprocessing
switch selectedDataSet
    case 1
        exampleNum=2;
        pos= eval(['data.xy' num2str(exampleNum)]);
        pos=smooth_butter(5,.15, pos);
        pos=pos-repmat(pos(end,:),size(pos,1),1);
        globalTraj = [pos gradient(pos')'];
        %todo rename globalTraj into modelTraj
        margin = 0.75; % choose margin
        exampleNum=2;
        disp(['Using sample ' num2str(exampleNum) ' out of 4']);
    case 2
        exampleNum=2;
        pos =data.demos{exampleNum}';
        globalTraj = [pos(:,1:2) gradient(pos(:,1:2)')'];
        %data.collectMPsequence{exampleNum}
        disp(['Using sample ' num2str(exampleNum) ' out of 3']);
        margin =  10; % choose margin
    case 3
        exampleNum=3;
        pos =data.demos{exampleNum}';
        globalTraj = [pos(:,1:2) gradient(pos(:,1:2)')'];
        %data.collectMPsequence{exampleNum}
        disp(['Using sample ' num2str(exampleNum) ' out of 3']);
        margin = 5; % choose margin
    case 4
        exampleNum=2;
        pos =data.demos{exampleNum}';
        globalTraj = [pos(:,1:2) gradient(pos(:,1:2)')'];
        %data.collectMPsequence{exampleNum}
        disp(['Using sample ' num2str(exampleNum) ' out of 3']);
        margin = 10; % choose margin
    case 5
        exampleNum=5;
       pos= eval(['data.xy' num2str(exampleNum)]);
        pos=smooth_butter(5,.15, pos);
        pos=pos-repmat(pos(end,:),size(pos,1),1);
        %pos=smooth_butter(5,.15, pos);
        globalTraj = [pos gradient(pos')'];
        
        margin = 0.0; % choose margin
        disp(['Using sample ' num2str(exampleNum) ' out of 100']);
    case 6
        exampleNum=2;
        pos = data.demos{exampleNum}';
        %pos=smooth_butter(5,.15, pos);
        globalTraj = [pos gradient(pos')'];
        dataMPsequence = data.collectMPsequence{exampleNum}';
        margin = 0.005; % choose margin
        disp(['Using sample ' num2str(exampleNum) ' out of 100']);
    case 7
        exampleNum=5;
        pos = data.demos{exampleNum}';
        %pos=smooth_butter(5,.15, pos);
        globalTraj = [pos gradient(pos')'];
        dataMPsequence = data.collectMPsequence{exampleNum}';
        margin = 0.005; % choose margin
        disp(['Using sample ' num2str(exampleNum) ' out of 100']);
    case 5
        keyboard
        pos= eval(['data.xy' num2str(exampleNum)]);
        %pos=smooth_butter(5,.15, pos);
        pos=pos-repmat(pos(end,:),size(pos,1),1);
        globalTraj = [pos gradient(pos')'];
        %todo rename globalTraj into modelTraj
        %keyboard;
        disp(['Using sample ' num2str(exampleNum) ' out of 4']);

    otherwise
        error('Do not know current dataNum ');
end
clear pos;
clear numModel;

%% initialising
run.iteration = 1;
run.finish = 0;

sequenceIndex{run.iteration}=[1 size(globalTraj,1)];
% TODO: sequenceIndex is the vector of segmentation point including

% I_err_Challenger is the index in the vector of segmentation points
% (sequenceIndex) chosen as a candidate to become an established
% segementatino point
% TODO reproGlobalTraj as currentSolutionTraj (might not be needed as
% we store the sequence of primitives

% TODO: corrGlobalTraj is better named resampledGlobalTraj

% TODO: this function evaluateGlobalTraj could be better explained in
% what it does and where are the primitives stored
%% configure maximal length of MP
ma1 = max(globalTraj(:,1));
mi1 = min(globalTraj(:,1));
mV1 = abs(ma1-mi1);
ma2 = max(globalTraj(:,2));
mi2 = min(globalTraj(:,2));
mV2 = abs(ma2-mi2);

if mV1<mV2
    mVmin= mV1;
    mVmax= mV2;
else
    mVmin= mV2;
    mVmax= mV1;
end
%option.mVmin=mVmin*margin;
option.mVmin=margin;
option.mVmax=mVmax;
logEval=[];

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('%%%%%%%%%%%%%%%%%%%%  Select new point %%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
[sequenceIndex I_err_Challenger I_err_Challenger_intersection logEval] =...
    evaluateGlobalTraj(sequenceIndex, globalTraj, modules, run.iteration,logEval,option);
corrGlobalTraj=logEval.corrGlobalTraj ;
reproGlobalTraj=logEval.reproGlobalTraj;

%% iterative decomposition loop
while ~run.finish
    %I_err_Challenger_intersection
    
    
    [indexAddedP errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration+1}(I_err_Challenger-1),...
        sequenceIndex{run.iteration+1}(I_err_Challenger), sequenceIndex{run.iteration+1}(I_err_Challenger+1), modules, globalTraj,option);
    
    if indexAddedP>0
        intersectionPointExists = 1;
        I_err_Challenger_intersection= I_err_Challenger_intersection(1);
    else
        run.finish = 1;
        disp('No intersection point found');
        disp('FINISH')
        
        break;
    end
    %% start plotting the results for each iterration
    clf(fig_Perf,'reset')
    subplotRow=2;
    subplotColm=1;
    [tmperr myindex]=max(trajectoryMeasureMSE(reproGlobalTraj,corrGlobalTraj));
    [fig traj]= PlotGlobalMovement(reproGlobalTraj(1:2,:),reproGlobalTraj(3:4,:),1,subplotRow,subplotColm,2,fig_Perf);
    
    [fig1 traj1]= PlotGlobalMovement(globalTraj(:,1:2)',globalTraj(:,3:4)',1,subplotRow,subplotColm,1,fig_Perf);
    clf(fig_Perf2,'reset')
    figure(fig_Perf2); hold on; grid on; box on;
    plot(globalTraj(:,1),globalTraj(:,2),'+');
    plot(reproGlobalTraj(1,:),reproGlobalTraj(2,:),'r+');
    line([reproGlobalTraj(1,myindex) corrGlobalTraj(1,myindex)],[reproGlobalTraj(2,myindex) corrGlobalTraj(2,myindex)] )
    daspect([1 1 1])
    
    disp(['tmperr: ' num2str(tmperr)]);
    
    % plot trajectory in which the next via point is set
    if I_err_Challenger>1 && I_err_Challenger<length(sequenceIndex{run.iteration+1})
        stPlot=sequenceIndex{run.iteration+1}(I_err_Challenger-1);
        endPlot=sequenceIndex{run.iteration+1}(I_err_Challenger+1);
        figure(fig1); hold on; plot(traj1(1,stPlot:endPlot),traj1(2,stPlot:endPlot),'r+')
    end
    % plot previous via points
    if run.iteration>1
        p= zeros(2,length(sequenceIndex{run.iteration-1}));
        for iseg = 1:length(sequenceIndex{run.iteration-1})
            p(:,iseg) = traj1(:,sequenceIndex{run.iteration-1}(iseg));
        end
        figure(fig1); hold on;
        plot(p(1,:),p(2,:),'or', 'MarkerSize',5,'LineWidth',5);
        %     line([reproGlobalTraj(1,myindex) corrGlobalTraj(1,myindex)],[reproGlobalTraj(2,myindex) corrGlobalTraj(2,myindex)] )
    end
    
    % plot current via points
    p= zeros(2,length(sequenceIndex{run.iteration}));
    for iseg = 1:length(sequenceIndex{run.iteration})
        p(:,iseg) = traj1(:,sequenceIndex{run.iteration}(iseg));
    end
    figure(fig1); hold on;
    plot(p(1,:),p(2,:),'og', 'MarkerSize',5,'LineWidth',5);
    figure(fig1);
    
    if record
        videoPath = ['./video/' fileName{selectedDataSet}]
        if ~exist(videoPath,'dir')
            mkdir(videoPath)
        end
        saveas(fig1,[videoPath filesep 'output' num2str(run.iteration)],'png')
    end
    
    
    %keyboard
    tmperr=max(trajectoryMeasureMSE(reproGlobalTraj,corrGlobalTraj));
    disp(['Max error: ' num2str(tmperr)])
    disp(' ')
    
    run.iteration = run.iteration + 1;
    
    
    % Check if new added point improves the Local approximation
    %[indexChallenged errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration}(I_err_Challenger-1)...
    %    ,sequenceIndex{run.iteration}(I_err_Challenger), sequenceIndex{run.iteration}(I_err_Challenger+1), modules, globalTraj);
    
    indexChallenged=I_err_Challenger;
    
    if indexChallenged < 0
        run.finish=1;
        run.iteration = run.iteration - 1;
        disp('FINISH')
        break
    end
    
    %% Challenge Via Points to the left and to the right of the new added Point and delete them if possible
    leftNeighbour = I_err_Challenger - 1;
    rightNeighbour = I_err_Challenger + 1;
    
    checkLeft = 0; checkRight = 0;
    if leftNeighbour > 1 && ~run.finish
        checkLeft = 1;
    end
    if rightNeighbour < length(sequenceIndex{run.iteration}) && ~run.finish
        checkRight = 1;
    end
    
    if checkLeft
        disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        disp('%%%%%%%%%%%%%%%%%%%%  challenge LEFT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        indexLeft=-1;
        jumpL=0;
        
        while indexLeft<0
            [indexLeft errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration}(leftNeighbour -1 -jumpL),...
                sequenceIndex{run.iteration}(leftNeighbour-jumpL), sequenceIndex{run.iteration}(I_err_Challenger), modules, globalTraj,option);
            jumpL=jumpL+1;
            if leftNeighbour-jumpL - 1 <1
                break;
            end
        end
        
        if indexLeft>0
            jumpL=jumpL-1;
        end
        if ~isempty(errorDescriptor)
            errTwoSegments= min(errorDescriptor.seg1_err,errorDescriptor.seg2_err);%errorDescriptor.seg12_err;
            errSingleSegment= errorDescriptor.seg3_err;
            disp(['Left errors two segments ' num2str(errTwoSegments) ' single ' num2str(errSingleSegment)]);
        end
        if indexLeft<0  || jumpL>0%errTwoSegments > errSingleSegment
            
            
            sequenceIndexnewL = sequenceIndex{run.iteration}(1:(leftNeighbour -jumpL));
            disp(' ');
            disp('Eliminating left point');
            disp(' ');
        else
            checkLeft = 0;
            sequenceIndexnewL = sequenceIndex{run.iteration}(1:leftNeighbour);
        end
    else
        sequenceIndexnewL = sequenceIndex{run.iteration}(1:leftNeighbour);
    end
    
    if checkRight
        
        disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        disp('%%%%%%%%%%%%%%%%%%%%  challenge RIGHT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        indexRight=-1;
        jumpR=0;
        
        while indexRight<0
            [indexRight errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration}(I_err_Challenger),...
                sequenceIndex{run.iteration}(rightNeighbour+jumpR), sequenceIndex{run.iteration}(rightNeighbour + 1+jumpR), modules, globalTraj,option);
            jumpR=jumpR+1;
            if rightNeighbour + 1+jumpR > length(sequenceIndex{run.iteration})
                break;
            end
        end
        if indexRight>0
            jumpR=jumpR-1;
        end
        
        if ~isempty(errorDescriptor)
            errTwoSegments= min(errorDescriptor.seg1_err,errorDescriptor.seg2_err);
            errSingleSegment= errorDescriptor.seg3_err;
            
            disp(['Right errors two segments ' num2str(errTwoSegments) ' single ' num2str(errSingleSegment)]);
        end
        if indexRight<0 || jumpR>0%errTwoSegments > errSingleSegment
            sequenceIndexnewR = sequenceIndex{run.iteration}((rightNeighbour+jumpR):end);
            disp('Eliminating right point');
        else
            sequenceIndexnewR = sequenceIndex{run.iteration}(rightNeighbour:end);
        end
    else
        sequenceIndexnewR = sequenceIndex{run.iteration}(rightNeighbour:end);
    end
    
    
    sequenceIndextmp=[ sequenceIndexnewL sequenceIndex{run.iteration}(I_err_Challenger) sequenceIndexnewR];
    [V I]  =  find(sequenceIndextmp == sequenceIndex{run.iteration}(I_err_Challenger));
    
    if length(I)>1
        disp('ente ente')
        keyboard
    end
    sequenceIndex{run.iteration}=sequenceIndextmp;
    
    
    
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    disp('%%%%%%%%%%%%%%%%%%%%  Select new point %%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    disp(['Iteration nr: ' num2str(run.iteration)]);
    [sequenceIndex I_err_Challenger I_err_Challenger_intersection logEval] =...
        evaluateGlobalTraj(sequenceIndex, globalTraj, modules, run.iteration, logEval,option);
    
    corrGlobalTraj=logEval.corrGlobalTraj ;
    reproGlobalTraj=logEval.reproGlobalTraj;
    reproGlobalTraj(3:4,:)=gradient(reproGlobalTraj(1:2,:));
    
end
close all;
fig_Perf=figure;hold on; grid on; box on;
subplotRow=2;
subplotColm=1;
reproGlobalTraj(3:4,:)=gradient(reproGlobalTraj(1:2,:));
[fig traj]= PlotGlobalMovement(reproGlobalTraj(1:2,:),reproGlobalTraj(3:4,:),1,subplotRow,subplotColm,2,fig_Perf);
[fig1 traj1]= PlotGlobalMovement(globalTraj(:,1:2)',globalTraj(:,3:4)',1,subplotRow,subplotColm,1,fig_Perf);
tmperr=max(trajectoryMeasureMSE(reproGlobalTraj,corrGlobalTraj));

p= zeros(2,length(sequenceIndex{run.iteration}));
for iseg = 1:length(sequenceIndex{run.iteration})
    figure(fig1); hold on;
    p(:,iseg) = traj1(:,sequenceIndex{run.iteration}(iseg));
    
end
plot(p(1,:),p(2,:),'og', 'MarkerSize',5,'LineWidth',5);

if record
    saveas(fig1,[videoPath filesep 'output' num2str(run.iteration)],'png')
    cmd =['ffmpeg -qscale 5 -r 1 -b 9600 -i ' videoPath filesep 'output%d.png movie.mp4'];
    system(cmd)
end
fig_Perf2=figure(); hold on; grid on; box on;
plot(globalTraj(:,1),globalTraj(:,2),'+');
plot(reproGlobalTraj(1,:),reproGlobalTraj(2,:),'r+');
%    savePath = ['./result/SegMethodV3/' name filesep NAME_MODEL(numModel).name filesep ];
end
