close all; clear all;
%
% fig_Perf=figure;
% hold on; grid on; box on;axis equal;
% fig_Perf2=figure;
% hold on; grid on; box on;axis equal;
include_paths;
%% Loading the module primitives

PATH_MODEL='model/Flash/';
NAME_MODEL = dir([PATH_MODEL '*X*']);
% TODO: consider changing the name "model" to model primitives

numModel = 3; % choose which set of primitives
load([PATH_MODEL NAME_MODEL(numModel).name]);
modules.shapes=result;
modules.borderbox=findBox(result);

name = NAME_MODEL(numModel).name;
clear numModel;
%% Load data

dataPath = ['data' filesep];

fileName{1} ='randTestDataDiscuntious2';
fileName{2} ='randTestDataDiscuntious2numSteps_7_maxV_1_X_Sym';
selectedDataSet = 2; % currently set 1 or 2
margin = 0.3;
for exampleNum=99:100; % current subdata set
    close all;
    clear fig_Perf
    clear fig_Perf2
    %     fig_Perf=figure;
    %     hold on; grid on; box on;axis equal;
    %     fig_Perf2=figure;
    %     hold on; grid on; box on;axis equal;
    %
    
    
    % randTestData also contains the optimal solution: this needs to be
    % clarified
    
    data = load([dataPath fileName{selectedDataSet}]);
    
    % data preprocessing
    switch selectedDataSet
        case 1
            pos = data.demos{exampleNum}';
            globalTraj = [pos gradient(pos')'];
            
            dataMPsequence = data.collectMPsequence{exampleNum}';
            disp(['Using sample ' num2str(exampleNum) ' out of 100']);
            
        case 2
            pos = data.demos{exampleNum}';
            %pos=smooth_butter(5,.15, pos);
            globalTraj = [pos gradient(pos')'];
            dataMPsequence = data.collectMPsequence{exampleNum}';
            
            disp(['Using sample ' num2str(exampleNum) ' out of 100']);
        otherwise
            error('Do not know current dataNum ');
    end
    clear pos;
    
    %% initialising
    run.iteration = 1;
    run.finish = 0;
    sequenceIndex={};
    sequenceIndex{run.iteration}=[1 size(globalTraj,1)];
    % TODO: sequenceIndex is the vector of segmentation point including
    
    % I_err_Challenger is the index in the vector of segmentation points
    % (sequenceIndex) chosen as a candidate to become an established
    % segementatino point
    % TODO reproGlobalTraj as currentSolutionTraj (might not be needed as
    % we store the sequence of primitives
    
    % TODO: corrGlobalTraj is better named resampledGlobalTraj
    
    % TODO: this function evaluateGlobalTraj could be better explained in
    % what it does and where are the primitives stored
    %% add noice
    %globalTraj = globalTraj + ((rand(size(globalTraj),1),size(globalTraj),2)) * 0.02) - 0.01) * (max - min)
    %% configure maximal length of MP
    ma1 = max(globalTraj(:,1));
    mi1 = min(globalTraj(:,1));
    mV1 = abs(ma1-mi1);
    ma2 = max(globalTraj(:,2));
    mi2 = min(globalTraj(:,2));
    mV2 = abs(ma2-mi2);
    
    % if mV1<mV2
    %     mVmin= mV1;
    %     mVmax= mV2;
    % else
    %     mVmin= mV2;
    %     mVmax= mV1;
    % end
    globalTraj = globalTraj + ((rand(size(globalTraj)) * 0.02) - 0.01) * min([mV1 mV2])/2;
    
    %option.mVmin=mVmin*margin;
    option.mVmin=margin;
    option.mVmax=max([ma1 ma2]);
    logEval=[];
    
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    disp('%%%%%%%%%%%%%%%%%%%%  Select new point %%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    [sequenceIndex I_err_Challenger I_err_Challenger_intersection logEval] =...
        evaluateGlobalTraj(sequenceIndex, globalTraj, modules, run.iteration,logEval,option);
    corrGlobalTraj=logEval.corrGlobalTraj ;
    reproGlobalTraj=logEval.reproGlobalTraj;
    if ~exist('fig_Perf2','var')
        fig_Perf2=figure; hold on; grid on; box on;
    end
    if ~exist('fig_Perf','var')
        fig_Perf=figure; hold on; grid on; box on;
    end
    %% iterative decomposition loop
    while ~run.finish
        %I_err_Challenger_intersection
        
        
        [indexAddedP errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration+1}(I_err_Challenger-1),...
            sequenceIndex{run.iteration+1}(I_err_Challenger), sequenceIndex{run.iteration+1}(I_err_Challenger+1), modules, globalTraj,option);
        
        if indexAddedP>0
            intersectionPointExists = 1;
            I_err_Challenger_intersection= I_err_Challenger_intersection(1);
        else
            run.finish = 1;
            disp('No intersection point found');
            disp('FINISH')
            break;
        end
        
        %% start plotting the results for each iterration
        
        clf(fig_Perf,'reset')
        subplotRow=2;
        subplotColm=1;
        [tmperr myindex]=max(trajectoryMeasureMSE(reproGlobalTraj,corrGlobalTraj));
        [fig traj]= PlotGlobalMovement(reproGlobalTraj(1:2,:),reproGlobalTraj(3:4,:),1,subplotRow,subplotColm,2,fig_Perf);
        
        [fig1 traj1]= PlotGlobalMovement(globalTraj(:,1:2)',globalTraj(:,3:4)',1,subplotRow,subplotColm,1,fig_Perf);
        
        clf(fig_Perf2,'reset')
        figure(fig_Perf2); hold on; grid on; box on;
        plot(globalTraj(:,1),globalTraj(:,2),'+');
        plot(reproGlobalTraj(1,:),reproGlobalTraj(2,:),'r+');
        line([reproGlobalTraj(1,myindex) corrGlobalTraj(1,myindex)],[reproGlobalTraj(2,myindex) corrGlobalTraj(2,myindex)] )
        daspect([1 1 1])
        
        tmperr=max(trajectoryMeasureMSE(reproGlobalTraj,corrGlobalTraj));
        disp(['Max error: ' num2str(tmperr)])
        pause
        
        run.iteration = run.iteration + 1;
        
        
        % Check if new added point improves the Local approximation
        %[indexChallenged errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration}(I_err_Challenger-1)...
        %    ,sequenceIndex{run.iteration}(I_err_Challenger), sequenceIndex{run.iteration}(I_err_Challenger+1), modules, globalTraj);
        
        indexChallenged=I_err_Challenger;
        
        if indexChallenged < 0
            run.finish=1;
            run.iteration = run.iteration - 1;
            disp('FINISH')
            break
        end
        
        %% Challenge Via Points to the left and to the right of the new added Point and delete them if possible
        leftNeighbour = I_err_Challenger - 1;
        rightNeighbour = I_err_Challenger + 1;
        
        checkLeft = 0; checkRight = 0;
        if leftNeighbour > 1 && ~run.finish
            checkLeft = 1;
        end
        if rightNeighbour < length(sequenceIndex{run.iteration}) && ~run.finish
            checkRight = 1;
        end
        
        if checkLeft
            disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
            disp('%%%%%%%%%%%%%%%%%%%%  challenge LEFT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
            disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
            indexLeft=-1;
            jumpL=0;
            
            while indexLeft<0
                [indexLeft errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration}(leftNeighbour -1 -jumpL),...
                    sequenceIndex{run.iteration}(leftNeighbour-jumpL), sequenceIndex{run.iteration}(I_err_Challenger), modules, globalTraj,option);
                jumpL=jumpL+1;
                if leftNeighbour-jumpL - 1 <1
                    break;
                end
            end
            
            if indexLeft>0
                jumpL=jumpL-1;
            end
            if ~isempty(errorDescriptor)
                errTwoSegments= min(errorDescriptor.seg1_err,errorDescriptor.seg2_err);%errorDescriptor.seg12_err;
                errSingleSegment= errorDescriptor.seg3_err;
                disp(['Left errors two segments ' num2str(errTwoSegments) ' single ' num2str(errSingleSegment)]);
            end
            if indexLeft<0  || jumpL>0%errTwoSegments > errSingleSegment
                
                
                sequenceIndexnewL = sequenceIndex{run.iteration}(1:(leftNeighbour -jumpL));
                disp(' ');
                disp('Eliminating left point');
                disp(' ');
            else
                checkLeft = 0;
                sequenceIndexnewL = sequenceIndex{run.iteration}(1:leftNeighbour);
            end
        else
            sequenceIndexnewL = sequenceIndex{run.iteration}(1:leftNeighbour);
        end
        
        if checkRight
            
            disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
            disp('%%%%%%%%%%%%%%%%%%%%  challenge RIGHT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
            disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
            indexRight=-1;
            jumpR=0;
            
            while indexRight<0
                [indexRight errorDescriptor] = challengeViaPoint(sequenceIndex{run.iteration}(I_err_Challenger),...
                    sequenceIndex{run.iteration}(rightNeighbour+jumpR), sequenceIndex{run.iteration}(rightNeighbour + 1+jumpR), modules, globalTraj,option);
                jumpR=jumpR+1;
                if rightNeighbour + 1+jumpR > length(sequenceIndex{run.iteration})
                    break;
                end
            end
            if indexRight>0
                jumpR=jumpR-1;
            end
            
            if ~isempty(errorDescriptor)
                errTwoSegments= min(errorDescriptor.seg1_err,errorDescriptor.seg2_err);
                errSingleSegment= errorDescriptor.seg3_err;
                
                disp(['Right errors two segments ' num2str(errTwoSegments) ' single ' num2str(errSingleSegment)]);
            end
            if indexRight<0 || jumpR>0%errTwoSegments > errSingleSegment
                sequenceIndexnewR = sequenceIndex{run.iteration}((rightNeighbour+jumpR):end);
                disp('Eliminating right point');
            else
                sequenceIndexnewR = sequenceIndex{run.iteration}(rightNeighbour:end);
            end
        else
            sequenceIndexnewR = sequenceIndex{run.iteration}(rightNeighbour:end);
        end
        
        
        sequenceIndextmp=[ sequenceIndexnewL sequenceIndex{run.iteration}(I_err_Challenger) sequenceIndexnewR];
        [V I]  =  find(sequenceIndextmp == sequenceIndex{run.iteration}(I_err_Challenger));
        
        if length(I)>1
            disp('ente ente')
            keyboard
        end
        sequenceIndex{run.iteration}=sequenceIndextmp;
        
        disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        disp('%%%%%%%%%%%%%%%%%%%%  Select new point %%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
        disp(['Iteration nr: ' num2str(run.iteration)]);
        [sequenceIndex I_err_Challenger I_err_Challenger_intersection logEval] =...
            evaluateGlobalTraj(sequenceIndex, globalTraj, modules, run.iteration, logEval,option);
        
        corrGlobalTraj=logEval.corrGlobalTraj ;
        reproGlobalTraj=logEval.reproGlobalTraj;
        reproGlobalTraj(3:4,:)=gradient(reproGlobalTraj(1:2,:));
        
    end
    %% SAVE RESULT
    savePath = ['result' filesep 'statistics' filesep...
        fileName{selectedDataSet} filesep name '_noisy' filesep num2str(margin) ]
    if ~exist(savePath,'dir')
        mkdir(savePath)
        mkdir([savePath filesep 'fig'])
    end
    
    originalMPsequence = dataMPsequence
    reproducedMPsequence = logEval.BestPrimitiv
  %  save([savePath filesep num2str(exampleNum) ], 'originalMPsequence','reproducedMPsequence','corrGlobalTraj','reproGlobalTraj','sequenceIndex','globalTraj')
    
    %     saveas(fig1,[savePath filesep 'fig' filesep num2str(exampleNum) ],'fig')
    %     print_pdf([savePath filesep 'fig' filesep num2str(exampleNum)], fig1);
    
end




















